## libcolumbus 0.4.0daily13.02.14

=== CMakeLists.txt ===
project(columbus C CXX)
cmake_minimum_required(VERSION 2.8.9)

if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

option(enable_tests "Enable tests." ON)
option(enable_scalability_tests "Additional scalability tests that are potentially very slow to run." OFF)
option(full_warnings "Full compiler warnings." ON)
option(debug_messages "Print debug messages.")
option(full_unicode "Enable full Unicode support (takes lots of memory).")
option(use_python2 "Build Python bindings against Python 2 (UNSUPPORTED)." OFF)

if(use_python2)
  message(WARNING "Python 2 bindings are NOT SUPPORTED! If they break, you get to keep both pieces.")
endif()

include(FindPkgConfig)
include(cmake/pch.cmake)
include(cmake/python.cmake)

if(${full_warnings})
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic")
endif()

if(${debug_messages})
  add_definitions(-DDEBUG_MESSAGES)
endif()

# Symbol visibility
add_definitions(-DBUILDING_COLUMBUS)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

set(SO_VERSION_MAJOR "0")
set(SO_VERSION_MINOR "4")
set(SO_VERSION_PATCH "0")

set(SO_VERSION "${SO_VERSION_MAJOR}.${SO_VERSION_MINOR}.${SO_VERSION_PATCH}")

set(COL_LIB_BASENAME "columbus${SO_VERSION_MAJOR}")

# Increment this manually whenever breaking ABI.
# http://tldp.org/HOWTO/Program-Library-HOWTO/shared-libraries.html#AEN135
set(ABI_VERSION 0)

# Set as cache variable so packaging can override.
set(LIBDIR "lib" CACHE PATH "Destination install dir for the library")
set(PYTHONDIR "lib/python3/dist-packages" CACHE PATH "Destination install dir for Python module")

include(TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)

if(full_unicode)
  if(${IS_BIG_ENDIAN})
    set(INTERNAL_ENCODING "UTF-32BE") # Iconv encoding string.
  else()
    set(INTERNAL_ENCODING "UTF-32LE")
  endif()
  set(LETTER_TYPE "uint32_t")
else()
  if(${IS_BIG_ENDIAN})
    set(INTERNAL_ENCODING "UCS-2BE//IGNORE") # Drop everything outside Base Multilingual Plane.
  else()
    set(INTERNAL_ENCODING "UCS-2LE//IGNORE")
  endif()
  set(LETTER_TYPE "uint16_t")
endif()  

find_file(HAS_SPARSE_HASH "google/sparse_hash_map")
if(HAS_SPARSE_HASH)
  message(STATUS "Using sparse hash.")
else()
  message(STATUS "Sparse hash not found, using regular hash.")
endif()

# Only required on some platforms.
# If not found, that's ok.
find_library(ICONV_LIBRARIES iconv)

pkg_search_module(GTK3 gtk+-3.0)

if(GTK3_FOUND)
  message(STATUS "GTK+ 3.0 found, building GUI apps.")
else()
  message(STATUS "GTK+ 3.0 not found, not building GUI apps.")
endif()

include_directories(include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

pkg_search_module(ICU icu-uc)

# Quantal and earlier do not have pkg-config files for icu.
# Find it manually.
if(NOT ICU_FOUND)
  find_library(icu1 icuuc)
  find_library(icu2 icudata)
  if(NOT icu1)
    message(FATAL_ERROR "Libicu not found. Please install it and rerun CMake.")
  endif()
  if(NOT icu2)
    message(FATAL_ERROR "Libicu not found. Please install it and rerun CMake.")
  endif()
  set(ICU_LIBRARIES ${icu1} ${icu2})
endif()

add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(share)

if(build_python)
  add_subdirectory(python)
endif()

if(${enable_tests})
  enable_testing()
  add_subdirectory(test)
endif()

## libcolumbus 0.4.0daily13.04.16~13.04

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,7 @@
 include(FindPkgConfig)
 include(cmake/pch.cmake)
 include(cmake/python.cmake)
+include(cmake/coverage.cmake)
 
 if(${full_warnings})
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic")

=== include/CMakeLists.txt ===
configure_file(ColumbusCore.hh.in ColumbusCore.hh)
install(FILES
${CMAKE_CURRENT_BINARY_DIR}/ColumbusCore.hh
Matcher.hh
MatchResults.hh
columbus.h
columbus.hh
Word.hh
WordList.hh
Corpus.hh
ErrorValues.hh
Document.hh
ColumbusHelpers.hh
IndexWeights.hh
DESTINATION include/${COL_LIB_BASENAME})

# Build and install a pkg-config file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix}/bin)
set(libdir ${prefix}/${LIBDIR})
set(includedir ${prefix}/include/${COL_LIB_BASENAME})
set(pkg-name "lib${COL_LIB_BASENAME}")
configure_file(libcolumbus.pc.in libcolumbus${SO_VERSION_MAJOR}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libcolumbus${SO_VERSION_MAJOR}.pc DESTINATION ${LIBDIR}/pkgconfig)

=== python/CMakeLists.txt ===
include_directories(${Boost_INCLUDE_DIR})
include_directories(${PYTHONLIBS_INCLUDE_DIRS})

if(use_python2)
  set(python_lib_name "_columbus")
else()
  set(python_lib_name "_columbus.${pysoabi}")
endif()

add_library(_columbus_ext SHARED _columbus.cc)
target_link_libraries(_columbus_ext ${COL_LIB_BASENAME} ${BOOST_PYTHON_HACK} ${PYTHONLIBS_LIBRARIES})
set_target_properties(_columbus_ext PROPERTIES OUTPUT_NAME ${python_lib_name} PREFIX "")

add_pch(pch/colpython_pch.hh _columbus_ext)

install(TARGETS _columbus_ext DESTINATION ${PYTHONDIR})
install(FILES columbus.py DESTINATION ${PYTHONDIR})

=== share/CMakeLists.txt ===
install(FILES
latinAccentedLetterGroups.txt
DESTINATION share/${COL_LIB_BASENAME})

=== src/CMakeLists.txt ===
add_library(${COL_LIB_BASENAME} SHARED
LevenshteinIndex.cc
IndexMatches.cc
ErrorValues.cc
Word.cc
ColumbusHelpers.cc
ColumbusSlow.cc
WordList.cc
Document.cc
Corpus.cc
Matcher.cc
MatchResults.cc
IndexWeights.cc
MatcherStatistics.cc
WordStore.cc
ColumbusCAPI.cc
ErrorMatrix.cc
ResultFilter.cc
Trie.cc
)

if(ICONV_LIBRARIES)
  target_link_libraries(${COL_LIB_BASENAME} ${ICONV_LIBRARIES})
endif()
target_link_libraries(${COL_LIB_BASENAME} ${ICU_LIBRARIES})

set_target_properties(${COL_LIB_BASENAME} PROPERTIES VERSION ${SO_VERSION} SOVERSION ${ABI_VERSION})

add_pch(pch/columbus_pch.hh ${COL_LIB_BASENAME})

install(
  TARGETS ${COL_LIB_BASENAME}
  ARCHIVE DESTINATION ${LIBDIR}
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${LIBDIR}
)

=== test/CMakeLists.txt ===
macro(coltest tname tfilename)
  add_executable(${tname} ${tfilename})
  target_link_libraries(${tname} ${COL_LIB_BASENAME})
  add_test(${tname} ${tname})
endmacro()

coltest(trie TrieTest.cc)
coltest(levtrie LevTrieTest.cc)
coltest(levindex LevIndexTest.cc)
coltest(custom_error CustomErrorTest.cc)
coltest(error_values ErrorValuesTest.cc)
coltest(word WordTest.cc)
coltest(wordlist WordListTest.cc)
coltest(document DocumentTest.cc)
coltest(corpus CorpusTest.cc)
coltest(matcher MatcherTest.cc)
coltest(matchresults MatchResultsTest.cc)
coltest(helpers HelpersTest.cc)
coltest(indexweights IndexWeightsTest.cc)
coltest(wordstore WordStoreTest.cc)
coltest(filtering ResultFilterTest.cc)
coltest(capi CAPITest.c)

add_executable(lev_scalability LevScalabilityTest.cc)
target_link_libraries(lev_scalability ${COL_LIB_BASENAME})
if(${enable_scalability_tests})
  add_test(lev_scalability lev_scalability /usr/share/dict/words)
endif()

if(build_python)
  add_test(python ${CMAKE_CURRENT_SOURCE_DIR}/pythontest.py)
  set_tests_properties(python PROPERTIES ENVIRONMENT "PYTHONPATH=${CMAKE_SOURCE_DIR}/python:${CMAKE_BINARY_DIR}/python")
endif()

add_executable(create_performance CreatePerformanceTest.cc)
target_link_libraries(create_performance ${COL_LIB_BASENAME})

## libcolumbus 0.9.0-1

=== debian/changelog ===
libcolumbus (0.9.0-1) unstable; urgency=low

  * Initial release

 -- Tom Swindell <t.swindell@rubyx.co.uk>  Mon, 27 Dec 2010 18:55:54 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# shared library versions, option 1
version=2.0.5
major=2
# option 2, assuming the library is created as src/.libs/libfoo.so.2.0.5 or so
#version=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
#major=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	qmake $(CURDIR)/libcolumbus.pro

	touch configure-stamp


build: build-stamp
build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) distclean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) INSTALL_ROOT="$(CURDIR)"/debian/libcolumbus install

	mkdir -p "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus/logging

	cp "$(CURDIR)"/src/*.h "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus
	rm "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus/{config,units}.h

	cp "$(CURDIR)"/src/logging/*.h "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus/logging
	rm "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus/logging/NMEAGeoLoggingFormatter.h

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installchangelogs 
#	dh_installdocs
#	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## libcolumbus 0.9.2-1

=== debian/changelog ===
libcolumbus (0.9.2-1) unstable; urgency=low

  * Added support for waypoints.
  * Fixed crashing issue.
  * Fix for issue with gps not initializing properly on some devices.

 -- Tom Swindell <t.swindell@rubyx.co.uk>  Sun, 09 Jan 2011 14:10:02 +0000

## libcolumbus 0.9.2-2

=== debian/changelog ===
libcolumbus (0.9.2-2) unstable; urgency=low

  * Packaging version bump for importing into extras.

 -- Tom Swindell <t.swindell@rubyx.co.uk>  Sun, 09 Jan 2011 14:26:14 +0000

=== debian/control ===
Source: libcolumbus
Priority: extra
Maintainer: Tom Swindell <t.swindell@rubyx.co.uk>
Build-Depends: debhelper (>= 5), libqt4-dev, libqtm-dev, librxsupport-dev
Standards-Version: 3.7.2
Section: libs

Package: libcolumbus-dev
Section: libdevel
Architecture: any
Depends: librxsupport-dev, libcolumbus (= ${Source-Version})
Description: Columbus application development headers

Package: libcolumbus
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Columbus application engine core

## libcolumbus 0.9.3-1

=== debian/changelog ===
libcolumbus (0.9.3-1) unstable; urgency=low

  * Updated source version.
  * Updated control file to rely on newer librxsupport version.

 -- Tom Swindell <t.swindell@rubyx.co.uk>  Wed, 19 Jan 2011 19:05:06 +0000

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Package: libcolumbus-dev
 Section: libdevel
 Architecture: any
-Depends: librxsupport-dev, libcolumbus (= ${Source-Version})
+Depends: librxsupport-dev (>= 0.2.0), libcolumbus (= ${Source-Version})
 Description: Columbus application development headers
 
 Package: libcolumbus

=== debian/rules ===
--- 
+++ 
@@ -66,7 +66,6 @@
 	mkdir -p "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus/logging
 
 	cp "$(CURDIR)"/src/*.h "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus
-	rm "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus/{config,units}.h
 
 	cp "$(CURDIR)"/src/logging/*.h "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus/logging
 	rm "$(CURDIR)"/debian/libcolumbus-dev/usr/include/rx/columbus/logging/NMEAGeoLoggingFormatter.h

## libcolumbus 1.0.0+13.10.20130814.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 option(enable_tests "Enable tests." ON)
 option(enable_scalability_tests "Additional scalability tests that are potentially very slow to run." OFF)
-option(full_warnings "Full compiler warnings." ON)
+option(full_warnings "All possible compiler warnings." OFF)
 option(debug_messages "Print debug messages.")
 option(full_unicode "Enable full Unicode support (takes lots of memory).")
 option(use_python2 "Build Python bindings against Python 2 (UNSUPPORTED)." OFF)
@@ -21,9 +21,11 @@
 include(cmake/python.cmake)
 include(cmake/coverage.cmake)
 
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -Wextra")
 if(${full_warnings})
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic")
+# C does not have any more warning flags.
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Weffc++")
 endif()
 
 if(${debug_messages})
@@ -35,20 +37,21 @@
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
 
-set(SO_VERSION_MAJOR "0")
-set(SO_VERSION_MINOR "4")
+set(SO_VERSION_MAJOR "1")
+set(SO_VERSION_MINOR "0")
 set(SO_VERSION_PATCH "0")
 
 set(SO_VERSION "${SO_VERSION_MAJOR}.${SO_VERSION_MINOR}.${SO_VERSION_PATCH}")
 
-set(COL_LIB_BASENAME "columbus${SO_VERSION_MAJOR}")
+set(COL_LIB_BASENAME "columbus")
 
 # Increment this manually whenever breaking ABI.
 # http://tldp.org/HOWTO/Program-Library-HOWTO/shared-libraries.html#AEN135
-set(ABI_VERSION 0)
+set(ABI_VERSION 1)
 
+include(GNUInstallDirs)
+set(LIBDIR ${CMAKE_INSTALL_LIBDIR})
 # Set as cache variable so packaging can override.
-set(LIBDIR "lib" CACHE PATH "Destination install dir for the library")
 set(PYTHONDIR "lib/python3/dist-packages" CACHE PATH "Destination install dir for Python module")
 
 include(TestBigEndian)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,7 @@
 ErrorMatrix.cc
 ResultFilter.cc
 Trie.cc
+SearchParameters.cc
 )
 
 if(ICONV_LIBRARIES)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,7 @@
 coltest(indexweights IndexWeightsTest.cc)
 coltest(wordstore WordStoreTest.cc)
 coltest(filtering ResultFilterTest.cc)
+coltest(searchparameters SearchParametersTest.cc)
 coltest(capi CAPITest.c)
 
 add_executable(lev_scalability LevScalabilityTest.cc)

## libcolumbus 1.1.0+14.04.20140325.3

=== include/CMakeLists.txt ===
configure_file(ColumbusCore.hh.in ColumbusCore.hh)
install(FILES
${CMAKE_CURRENT_BINARY_DIR}/ColumbusCore.hh
Matcher.hh
MatchResults.hh
columbus.h
columbus.hh
Word.hh
WordList.hh
Corpus.hh
ErrorValues.hh
Document.hh
ColumbusHelpers.hh
IndexWeights.hh
DESTINATION include/${COL_LIB_BASENAME}${SO_VERSION_MAJOR})

# Build and install a pkg-config file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix}/bin)
set(libdir ${prefix}/${LIBDIR})
set(includedir ${prefix}/include/${COL_LIB_BASENAME}${SO_VERSION_MAJOR})
set(pkg-name "lib${COL_LIB_BASENAME}")
configure_file(libcolumbus.pc.in libcolumbus.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libcolumbus.pc DESTINATION ${LIBDIR}/pkgconfig)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,11 @@
   add_test(${tname} ${tname})
 endmacro()
 
-coltest(trie TrieTest.cc)
+# Trie is an internal class whose symbols are hidden
+# so we need to add the source manually.
+add_executable(trie TrieTest.cc ../src/Trie.cc)
+target_link_libraries(trie ${COL_LIB_BASENAME})
+add_test(trie trie)
 coltest(levtrie LevTrieTest.cc)
 coltest(levindex LevIndexTest.cc)
 coltest(custom_error CustomErrorTest.cc)

=== tools/CMakeLists.txt ===
add_executable(queryindex queryindex.cc)
target_link_libraries(queryindex ${COL_LIB_BASENAME})

if(GTK3_FOUND)
  include_directories(${GTK3_INCLUDE_DIRS})
  add_executable(singleword singleword.cc)
  target_link_libraries(singleword ${COL_LIB_BASENAME} ${GTK3_LIBRARIES})
  
  add_executable(queryapp queryapp.cc)
  target_link_libraries(queryapp ${COL_LIB_BASENAME} ${GTK3_LIBRARIES})

  add_executable(hudtest hudtest.cc)
  target_link_libraries(hudtest ${COL_LIB_BASENAME} ${GTK3_LIBRARIES})

  add_executable(sctest sctest.cc)
  target_link_libraries(sctest ${COL_LIB_BASENAME} ${GTK3_LIBRARIES})

  add_executable(numberpad numberpad.cc)
  target_link_libraries(numberpad ${COL_LIB_BASENAME} ${GTK3_LIBRARIES})

endif()

## libcolumbus 1.1.0+15.10.20150806

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,10 +35,10 @@
 # Symbol visibility
 add_definitions(-DBUILDING_COLUMBUS)
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
 
 set(SO_VERSION_MAJOR "1")
-set(SO_VERSION_MINOR "0")
+set(SO_VERSION_MINOR "1")
 set(SO_VERSION_PATCH "0")
 
 set(SO_VERSION "${SO_VERSION_MAJOR}.${SO_VERSION_MINOR}.${SO_VERSION_PATCH}")

=== python/CMakeLists.txt ===
include_directories(${Boost_INCLUDE_DIR})
include_directories(${PYTHONLIBS_INCLUDE_DIRS})

if(use_python2)
  set(python_lib_name "columbus")
else()
  set(python_lib_name "columbus.${pysoabi}")
endif()

add_library(columbus_ext SHARED columbus.cc)
target_link_libraries(columbus_ext ${COL_LIB_BASENAME} ${BOOST_PYTHON_HACK} ${PYTHONLIBS_LIBRARIES})
set_target_properties(columbus_ext PROPERTIES OUTPUT_NAME ${python_lib_name} PREFIX "")

add_pch(pch/colpython_pch.hh columbus_ext)

install(TARGETS columbus_ext DESTINATION ${PYTHONDIR})

=== share/CMakeLists.txt ===
install(FILES
latinAccentedLetterGroups.txt
greekAccentedLetterGroups.txt
DESTINATION share/${COL_LIB_BASENAME}${SO_VERSION_MAJOR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -25,8 +25,11 @@
 endif()
 target_link_libraries(${COL_LIB_BASENAME} ${ICU_LIBRARIES})
 
+set(symbol_map "${CMAKE_CURRENT_SOURCE_DIR}/libcolumbus.map")
 set_target_properties(${COL_LIB_BASENAME} PROPERTIES VERSION ${SO_VERSION} SOVERSION ${ABI_VERSION})
-
+set_target_properties(${COL_LIB_BASENAME} PROPERTIES
+    LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}")
+set_target_properties(${COL_LIB_BASENAME} PROPERTIES LINK_DEPENDS ${symbol_map})
 add_pch(pch/columbus_pch.hh ${COL_LIB_BASENAME})
 
 install(
